﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.UltraChart.Resources;
using Infragistics.UltraChart.Shared.Styles;

namespace TimeSpanChartTest
{
	public partial class Form1 : Form
	{
		private DataTable data;

		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			var rnd = new Random();
			data = new DataTable();

			data.Columns.Add("Car", typeof(String));
			data.Columns.Add("Acceleration Time", typeof(int));

			for (int i = 0; i < 10; i++)
			{
				var row = data.NewRow();
				row.ItemArray = new object[] { "Car " + i.ToString(), rnd.Next(20000) };
				data.Rows.Add(row);
			}

			ultraChart1.DataSource = data;
			ultraChart1.Data.SwapRowsAndColumns = true;
			ultraChart1.Axis.Y.Labels.ItemFormat = AxisItemLabelFormat.Custom;
			ultraChart1.Axis.Y.Labels.ItemFormatString = "<MyLabelRenderer>";
			ultraChart1.Tooltips.FormatString = "<MyLabelRenderer>";
			var hashTable = new Hashtable();
			var renderer = new MyLabelRenderer();
			hashTable.Add("MyLabelRenderer", renderer);
			ultraChart1.LabelHash = hashTable;
		}
	}

	class MyLabelRenderer : IRenderLabel
	{
		#region IRenderLabel Members

		public string ToString(Hashtable context)
		{
			var location = (LabelRenderLocation)context["LABEL_RENDER_LOCATION"];
			if (location == LabelRenderLocation.Axis || location == LabelRenderLocation.AdornmentLayer)
			{
				double dataValue = (double)context["DATA_VALUE"];
				return ((int)(dataValue / 1000)).ToString() + "." + (dataValue % 1000).ToString();
			}

			return context["DATA_VALUE"].ToString();
		}

		#endregion
	}
}
